<?php
namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;

class FechamentoMensalRepository {
    
    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }
    
    
    public function possuiPonto($nrorg, $nrvinculom, $nrperiodoapuracao){
        
        $params = array('P_NRVINCULOM'=>$nrvinculom, 'P_PERIODO'=>$nrperiodoapuracao, 'P_NRORG'=>$nrorg);
$query = <<<SQL
SELECT 1 FROM PTO_RESUMOSITUFREQ RSF
                WHERE RSF.QTREFAPURSITUFREQ > 0
                  AND RSF.NRVINCULOM         = :P_NRVINCULOM
                  AND RSF.NRPERIODOAPURACAO  = :P_PERIODO
                  AND RSF.NRORG              = :P_NRORG
                  AND EXISTS ( SELECT 1 FROM GPE_MARCACAOPONTO /*se não houver marcação este não traz o horário de almoço*/
                               WHERE NRCOLETOR != 21 /*evita as balizas*/
                                 AND IDMARCDESPREZADA = 'N'
                                 AND NRORG      = RSF.NRORG
                                 AND NRVINCULOM = RSF.NRVINCULOM
                                 AND TRUNC(DTHRMARCACAOPONTO, 'DD') = RSF.DTAPURACAOSITUFREQ )
SQL;
        $result = $this->connection->fetchAll($query, $params);
        return !empty($result);        
    }
    
} 
