-- ============================================================
-- Database name: FOLHA
-- Created on: 23/08/2020
-- ============================================================
-- ============================================================
-- Table: ESO_MIGRACAOXML
-- ============================================================
create table ESO_MIGRACAOXML
(
    NRORG NUMBER not null,
    NRMIGRACAOXML NUMBER not null,
    NMEVENTO VARCHAR2(10) not null,
    DSVERSAO VARCHAR2(10) null,
    NMARQUIVOXML VARCHAR2(1000) not null,
    DSARQUIVOXML VARCHAR2(1000) not null,
    IDSTATUS VARCHAR2(1) default 'P' not null,
    IDATIVO VARCHAR2(1) default 'S' not null,
    DTINCLUSAO DATE default SYSDATE not null,
    DTULTATU DATE null,
    NRORGINCLUSAO NUMBER(22) default 1 null,
    CDOPERINCLUSAO VARCHAR2(12) default '1' null,
    NRORGULTATU NUMBER(22) default 1 null,
    CDOPERULTATU VARCHAR2(12) default '1' null,
    
    constraint PK_ESO_MIGRACAOXML primary key (NRORG, NRMIGRACAOXML),
    constraint CKC_IDSTATUS_ESO_MIGRA CHECK (IDSTATUS IN ('P','C'))
)
/
-- ============================================================
-- Index: ESO_MIGRACAOXML_01
-- ============================================================
create index ESO_MIGRACAOXML_01 on ESO_MIGRACAOXML (NRORG asc, DTINCLUSAO asc)
/
-- ============================================================
-- Index: ESO_MIGRACAOXML_02
-- ============================================================
create index ESO_MIGRACAOXML_02 on ESO_MIGRACAOXML (NRORG asc, NMEVENTO asc)
/
-- ============================================================
-- Table: ESO_LOGMIGRACAOXML
-- ============================================================
create table ESO_LOGMIGRACAOXML
(
    NRORG NUMBER not null,
    NRLOGMIGRACAOXML NUMBER not null,
    NRMIGRACAOXML NUMBER not null,
    DSMENSAGEM VARCHAR2(4000) not null,
    IDATIVO VARCHAR2(1) default 'S' not null,
    DTINCLUSAO DATE default SYSDATE not null,
    DTULTATU DATE null,
    NRORGINCLUSAO NUMBER(22) default 1 null,
    CDOPERINCLUSAO VARCHAR2(12) default '1' null,
    NRORGULTATU NUMBER(22) default 1 null,
    CDOPERULTATU VARCHAR2(12) default '1' null,
    
    constraint PK_ESO_LOGMIGRACAOXML primary key (NRORG, NRLOGMIGRACAOXML),
    constraint FK_ESO_LOGMIGRACAOXML foreign key (NRORG, NRMIGRACAOXML)
        references ESO_MIGRACAOXML (NRORG, NRMIGRACAOXML)
)
/
create index ESO_LOGMIGRACAOXML_FK on ESO_LOGMIGRACAOXML (NRORG, NRMIGRACAOXML)
/

-- ============================================================
-- Database name: FOLHA
-- Created on: 23/12/2020
-- ============================================================
-- ============================================================
-- Table: ESO_MIGRACAOXML
-- ============================================================
ALTER TABLE ESO_MIGRACAOXML DROP CONSTRAINT CKC_IDSTATUS_ESO_MIGRA
/
ALTER TABLE ESO_MIGRACAOXML ADD CONSTRAINT CKC_IDSTATUS_ESO_MIGRA CHECK (IDSTATUS IN ('P','A','C'))
/

-- ============================================================
-- Database name: FOLHA
-- Created on: 24/12/2020
-- ============================================================
-- ============================================================
-- Table: ESO_LOGMIGRACAOXML
-- ============================================================
ALTER TABLE ESO_LOGMIGRACAOXML DROP CONSTRAINT FK_ESO_LOGMIGRACAOXML
/
ALTER TABLE ESO_LOGMIGRACAOXML ADD CONSTRAINT FK_ESO_LOGMIGRACAOXML FOREIGN KEY (NRORG, NRMIGRACAOXML)
    REFERENCES ESO_MIGRACAOXML (NRORG, NRMIGRACAOXML) ON DELETE CASCADE
/