/* Sistemas Integrados TECNISA

Nome: 02CW_GERTRGO_LOG_MOVBANCARIO

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   26/05/2006 - ANDR RODRIGO
*/

CREATE OR REPLACE TRIGGER LOG_MOVBANCARIO
AFTER DELETE OR INSERT OR UPDATE
ON MOVBANCARIO FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(40);
  V_DESC       VARCHAR2(300);
  V_DTOPER     DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   NMUSUARIO(V_USUARIO);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF NOT V_USUARIO IS NULL THEN
      IF DELETING  THEN
         V_TIPO := '3';

         V_DESC   := 'CONTA= '       || :OLD.CDREDUCONT     || ' ' ||
                     'DATA= '        || :OLD.DTMOVBANC      || ' ' ||
                     'VALOR= '       || ROUND(:OLD.VRMOVBANC, 2) || ' ' ||
                     'DESCRIO= '   || :OLD.DSHISMBANC    || ' ' ||
                     'ORIGEM= '      || :OLD.IDORIGMBANC ;

         IF (:OLD.IDCONCBANC IS NOT NULL) THEN
             V_DESC := V_DESC || ' CONCILIAO= ' || :OLD.IDCONCBANC;
         END IF;

         V_ITPESQ  := :OLD.CDREDUCONT || :OLD.NRMOVBANC;
      ELSE
         IF UPDATING THEN
            IF (:OLD.CDREDUCONT   <> :NEW.CDREDUCONT)  OR
               (:OLD.NRMOVBANC    <> :NEW.NRMOVBANC)   OR
               (:OLD.DTMOVBANC    <> :NEW.DTMOVBANC)   OR
               (:OLD.IDMOVBANC    <> :NEW.IDMOVBANC)   OR
               (:OLD.NRDOCMBANC   <> :NEW.NRDOCMBANC)  OR
               (:OLD.DSHISMBANC   <> :NEW.DSHISMBANC)  OR
               (:OLD.VRMOVBANC    <> :NEW.VRMOVBANC)   OR
               (:OLD.IDORIGMBANC  <> :NEW.IDORIGMBANC) OR
               (:OLD.IDSTCONEXT   <> :NEW.IDSTCONEXT)  OR
               (:OLD.IDERCONEXT   <> :NEW.IDERCONEXT)  OR
               (:OLD.IDCONCBANC   <> :NEW.IDCONCBANC)  OR
               (:OLD.CDSEQUEXBA   <> :NEW.CDSEQUEXBA)  OR
               (:OLD.NRSEQMOVREBA <> :NEW.NRSEQMOVREBA) THEN

               V_DESC   := 'CONTA= '       || :OLD.CDREDUCONT     || ' ' ||
                           'DATA= '        || :OLD.DTMOVBANC      || ' ' ||
                           'VALOR= '       || ROUND(:OLD.VRMOVBANC, 2) || ' ' ||
                           'DESCRIO= '   || :OLD.DSHISMBANC    || ' ' ||
                           'ORIGEM= '      || :OLD.IDORIGMBANC;

               IF (:OLD.IDMOVBANC <> :NEW.IDMOVBANC) THEN
                   V_DESC := V_DESC || ' IDMOVBANC= ' || :OLD.IDMOVBANC;
               END IF;
               IF (:OLD.NRDOCMBANC <> :NEW.NRDOCMBANC) THEN
                  V_DESC := V_DESC || ' NRDOCMBANC= ' || :OLD.NRDOCMBANC;
               END IF;
               IF (:OLD.IDSTCONEXT <> :NEW.IDSTCONEXT) THEN
                  V_DESC := V_DESC || ' IDSTCONEXT= '  || :OLD.IDSTCONEXT;
               END IF;
               IF (:OLD.IDERCONEXT <> :NEW.IDERCONEXT) THEN
                  V_DESC := V_DESC || ' IDERCONEXT= '    || :OLD.IDERCONEXT;
               END IF;
               IF (:OLD.IDCONCBANC <> :NEW.IDCONCBANC) THEN
                  V_DESC := V_DESC || ' CONCILIAO= '   || :OLD.IDCONCBANC;
               END IF;
               IF (:OLD.CDSEQUEXBA <> :NEW.CDSEQUEXBA) THEN
                  V_DESC := V_DESC || ' CDSEQUEXBA= '   || :OLD.CDSEQUEXBA;
               END IF;
               IF (:OLD.NRSEQMOVREBA <> :NEW.NRSEQMOVREBA) THEN
                  V_DESC := V_DESC || ' NRSEQMOVREBA= '   || :OLD.NRSEQMOVREBA;
               END IF;
            END IF;

            V_ITPESQ  := :OLD.CDREDUCONT || :OLD.NRMOVBANC;
            V_TIPO := '2';
         ELSE
            IF INSERTING THEN
               V_DESC   := 'CONTA= '       || :NEW.CDREDUCONT     || ' ' ||
                           'DATA= '        || :NEW.DTMOVBANC      || ' ' ||
                           'VALOR= '       || ROUND(:NEW.VRMOVBANC, 2) || ' ' ||
                           'DESCRIO= '   || :NEW.DSHISMBANC    || ' ' ||
                           'ORIGEM= '      || :NEW.IDORIGMBANC;

               IF (:NEW.IDCONCBANC IS NOT NULL) THEN
                   V_DESC := V_DESC || ' CONCILIAO= ' || :NEW.IDCONCBANC;
               END IF;

               V_TIPO   := '1';
               V_ITPESQ := :NEW.CDREDUCONT || :NEW.NRMOVBANC;
            END IF;
         END IF;
      END IF;

      IF V_TIPO <> '0' THEN
         IF NOT V_DESC IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,      DTOPERACAO,   NMRESPOPER,
                IDTIPOOPER,    CDPESQITEM,   DSOPERACAO,
                DSRDMUSUOPER,  DSENDUSUOPER, DSNMUSUOPER,
                DSMETUSUOPER,  CDORESPOPER)
            VALUES
               ('MOVBANCARIO',  V_DTOPER,        V_USUARIO,
                V_TIPO,         V_ITPESQ,        V_DESC,
                V_DSSERVERRDM,  V_DSREMOTEADDR,  V_DSREMOTEHOST,
                V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/
